#include <stdio.h>
#include <stdlib.h>

#define MEM_COUNT 10

int main(void)
{
	const int memSize = 128;
	int i;
	char **head;
	char *mem[MEM_COUNT + 1];

	for (i = 0 ; i < MEM_COUNT ; i++) {
		mem[i] = malloc(memSize);
		if (mem[i]) {
			snprintf(mem[i], memSize, "memory%d", i);
		}
	}
	mem[i] = NULL;

	head = &mem[0];
	while (*head) {
		printf("%s\n", *head);
		head++;
	}

	for (i = 0 ; i < MEM_COUNT ; i++) {
		free(mem[i]);
	}

	return 0;
}

